
\chapter{Install and base configuration}
\label{cap:install}
In this chapter, we will explain how to install GExTools and configure it.

\section{Install}

\subsection{Ruby}
You must have a recent version of ruby (version > 1.9.x). \\
If you haven't an up-to-date ruby program already installed, you can fetch it, and get installation instruction on: \verb!http://www.ruby-lang.org/en/downloads/!.\\

\subsection{Gems}
\verb!RubyGems! are ruby applications or libraries's packages. \\
This is the list of the required packages :
\begin{description}
 \item{trollop} which is a command line option parser
 \item{rake} which is the ruby equivalent of the (un)famous \verb!make! command
 \item{net-ssh} which deals with ssh connection
 \item{net-ssh-multi} which deals with multiple parallel ssh connections
 \item{net-scp} which deals with ssh file transfers
 \item{builder} which deals with xml file creation
 \item{xml-simple} which deals with xml parsing
 \item{tzinfo} which deals with timezone conversions
 \item{googlecharts} which is a ruby library used to build graphics.
 \item{awesome\_print} which deals with printing information on console.
 \item{mysql2} which is an interface to access mysql databases
 \item{activerecord} which is a famous ruby implementation of the active record design pattern 
	(which consists in mapping relational database tables into classes/objects)
\end{description}

\subsection{Base Path}
Just put the GExTools folder in any place/folder you would like it to be. You also must create the \emph{database.yml} and \emph{component.yml} file on the default GExTools configuration folder (\emph{.gextools}) which is located in your home directory. The creation of these files are detailed on the next sections.

\subsection{Database configuration}
In order to create the required tables in the database, you have to create a database configuration file with information on how to 
connect to this database. \\
Create a file named \verb!database.yml! (an example file named \verb!database.yml.example! is also provided) in the default GExTools configuration directory, containing :

\begin{lstlisting} [style=ruby]
development:
    adapter: mysql2
    database: theNameOfYourDatabase
    host: theNameOfYourHost		# If you are using 'localhost' you can suppress this option
    username: putYourUserNameHere_development
    password: putYourPasswordNameHere
test:
    adapter: mysql2
    database: theNameOfYourDatabase
    host: theNameOfYourHost		# If you are using 'localhost' you can suppress this option
    username: putYourUserNameHere
    password: putYourPasswordNameHere_test
production:
    adapter: mysql2
    database: theNameOfYourDatabase
    host: theNameOfYourHost		# If you are using 'localhost' you can suppress this option
    username: putYourUserNameHere
    password: putYourPasswordNameHere
\end{lstlisting}
(with the fields \verb!database!, \verb!username!, \verb!password! set in accordance with your preference).

You can use different database environments described on your \verb!database.yml!. Manage different environments will be useful only if you want to create extensions for gexTools. In this case, the utilisation of each profile will depends of the environment variable \verb!DATABASE_ENV!. If you want to use the \verb!test! environment, for example, you will need to do (in UNIX): \\

\begin{lstlisting} [style=bash]
export DATABASE_ENV="test"
\end{lstlisting}

By default, GExTools will be installed and configured only to use the production environment. Each parameter contained on this file is further described on \ref{confFiles}.

\subsection{Install}
To install everything that is needed by GExTools, use the following command, in its core directory: \\

\begin{lstlisting} [style=bash]
bundle install
\end{lstlisting}

To just migrate create the GExTools schema (based on the environment indicated by \verb!DATABASE_ENV!), use the following command (if you are using GExTools code, the \emph{gextools} script is on the \emph{bin} directory of the core component, otherwise, if you have installed GExTools as a gem, it will be already moved to your system's bin directory) : \\

\begin{lstlisting} [style=bash]
gextools db:create
\end{lstlisting}

To just migrate the required tables in the database, use the following command : \\

\begin{lstlisting} [style=bash]
gextools db:migrate
\end{lstlisting}

\section{Component Configuration}
You have to create a component configuration file that indicate the program and grid component to be used.
On the default GExTools's configuration directory (\emph{.gextools}, create a file named \verb!component.yml!. It is a YAML formated file. \\
Edit it, so that it will look like this: \\
\begin{lstlisting} [style=ruby]
---
:component: COMPONENT_NAME
:component_dev_path: PATH
:grid: GRID_COMPONENT_NAME
:grid_dev_path: PATH
:gridPasswd: PASSWORD
:gridLogin: GRID_USERNAME
:gridHostname: GRID_HOST
\end{lstlisting}

Each parameter contained on this file is further described on \ref{confFiles}.